(function() {
  var action, appPath, args, build, builder, fs, options, path, publicDir, server, serverDir, serverPort;
  path = require("path");
  args = require("optimist").argv;
  action = args._[0];
  options = args._.slice(1);
  build = require("./builder");
  fs = require("fs");
  switch (action) {
    case "server":
    case "serve":
      serverDir = path.resolve(options[0] || ".");
      serverPort = options[1] || 8080;
      server = require("./server");
      server.serve(serverDir, serverPort);
      break;
    case "build":
      appPath = path.resolve(options[0] || ".");
      publicDir = path.resolve(options[1] || "./public");
      options = options.slice(2) || {};
      options.root = appPath;
      builder = new build(appPath, publicDir, options);
      builder.build(function(err, html) {
        if (err) {
          throw err;
        }
        return fs.writeFile(publicDir + "/build.html", html, "utf8", function(err) {
          if (err) {
            throw err;
          }
          return console.log("Successfully built " + appPath);
        });
      });
  }
}).call(this);
