(function() {
  var fs, getHeader, middleware, mime, path, plugin;
  path = require("path");
  fs = require("fs");
  mime = require("mime");
  plugin = require("./plugin");
  middleware = exports.middleware = function(appDir) {
    return function(req, res, next) {
      var Plugin, assetPath, root, url;
      root = appDir;
      url = req.url;
      assetPath = path.resolve(root + url);
      Plugin = plugin(url);
      if (Plugin === false) {
        next();
        return;
      }
      return fs.readFile(assetPath, "utf8", function(err, contents) {
        var output;
        if (err) {
          throw err;
        }
        output = function(err, out) {
          var header;
          if (err) {
            throw err;
          }
          if (!res.getHeader("content-type")) {
            header = getHeader("blah." + Plugin.type);
            res.setHeader('Content-Type', header);
          }
          return res.send(out);
        };
        return Plugin.render(contents, assetPath, output);
      });
    };
  };
  getHeader = function(assetPath) {
    var charset, type;
    type = mime.lookup(assetPath);
    charset = mime.charsets.lookup(type);
    charset = charset ? "; charset=" + charset : "";
    return type + charset;
  };
  module.exports = exports.middleware;
}).call(this);
