(function() {
  var $, CommentParser, assetTypes, fs, isString, jsdom, path, utils, _;
  utils = require("../utils");
  _ = require("underscore");
  $ = require("jquery");
  fs = require("fs");
  jsdom = require("jsdom").jsdom;
  path = require("path");
  assetTypes = {
    js: "script",
    css: "link",
    images: "img",
    embeds: "embed",
    iframes: "iframe",
    videos: "video",
    audio: "audio"
  };
  CommentParser = (function() {
    function CommentParser(document, main) {
      this.document = document;
      this.main = main;
      this.document = jsdom(document);
    }
    CommentParser.prototype.pull = function(element) {
      var child, children, current, output, self, _i, _len;
      if (element == null) {
        element = this.document;
      }
      output = [];
      self = this;
      current = element;
      children = current.childNodes;
      for (_i = 0, _len = children.length; _i < _len; _i++) {
        child = children[_i];
        if (child.nodeType === 8) {
          output.push(child);
        } else {
          output = output.concat(self.pull(child));
        }
      }
      return output;
    };
    CommentParser.prototype.parse = function(document, directory, callback) {
      var commands, comment, comments, finished, numCommands, parser, regex, text, _i, _len;
      if (document == null) {
        document = this.document;
      }
      if (directory == null) {
        directory = this.main;
      }
      parser = this;
      comments = this.pull(document);
      regex = /(include) ["']([\w\/.-]+)["']/;
      commands = [];
      for (_i = 0, _len = comments.length; _i < _len; _i++) {
        comment = comments[_i];
        text = comment.nodeValue;
        if (regex.test(text)) {
          commands.push(comment);
        }
      }
      numCommands = commands.length;
      if (numCommands === 0) {
        callback(document);
      }
      finished = utils.countdown(numCommands);
      return $(commands).each(function(index, comment) {
        var command, file, match, source, _ref;
        _ref = comment.nodeValue.match(regex), match = _ref[0], command = _ref[1], source = _ref[2];
        file = directory + "/" + source;
        return fs.readFile(file, "utf8", function(err, contents) {
          var documentFragment, output;
          if (err) {
            throw err;
          }
          documentFragment = jsdom(contents);
          parser.fixPaths(documentFragment, path.dirname(source));
          output = function(fragment) {
            $(comment).replaceWith(fragment.innerHTML);
            if (finished()) {
              return callback(document);
            }
          };
          return parser.parse(documentFragment, path.dirname(file), output);
        });
      });
    };
    CommentParser.prototype.fixPaths = function(document, path) {
      var attribute, tag, type, _results;
      _results = [];
      for (type in assetTypes) {
        tag = assetTypes[type];
        attribute = type === "css" ? "href" : "src";
        _results.push($(tag, document).each(function(i, element) {
          return $(element).attr(attribute, path + "/" + element[attribute]);
        }));
      }
      return _results;
    };
    return CommentParser;
  })();
  isString = function(obj) {
    return !!(obj === '' || (obj && obj.charCodeAt && obj.substr));
  };
  module.exports = CommentParser;
}).call(this);
