(function() {
  var HTMLElements, define, patch;
  HTMLElements = {
    "HTMLEmbedElement": {
      tagName: "EMBED",
      attributes: ["src", "type"]
    }
  };
  patch = exports.patch = function(jsdom) {
    var attributes, core, elem;
    core = exports.core = jsdom.dom.level3.core;
    for (elem in HTMLElements) {
      attributes = HTMLElements[elem];
      define(elem, attributes);
    }
    return jsdom.jsdom;
  };
  define = exports.define = function(elementClass, def) {
    var attrs, core, elem, parentClass, proto, tagName, tagNames, __proto__;
    core = exports.core;
    tagName = def.tagName;
    tagNames = def.tagNames || (tagName ? [tagName] : []);
    parentClass = def.parentClass || core.HTMLElement;
    attrs = def.attributes || [];
    proto = def.proto || {};
    elem = core[elementClass] = function(document, name) {
      parentClass.call(this, document, name || tagName.toUpperClass());
      if (elem._init) {
        return elem._init.call(this);
      }
    };
    elem._init = def.init;
    elem.prototype = proto;
    elem.prototype = __proto__ = parentClass.prototype;
    return attrs.forEach(function(n) {
      var attr, prop;
      prop = n.prop || n;
      attr = n.attr || prop.toLowerCase();
      if (!n.prop || n.read !== false) {
        elem.prototype.__defineGetter__(prop, function() {
          var s;
          s = this.getAttribute(attr);
          if (n.type && n.type === 'boolean') {
            return !!s;
          }
          if (n.type && n.type === 'long') {
            return +s;
          }
          if (n.normalize) {
            return n.normalize(s);
          }
          return s;
        });
      }
      if (!n.prop || n.write !== false) {
        return elem.prototype.__defineSetter__(prop, function(val) {
          var s;
          if (!val) {
            return this.removeAttribute(attr);
          } else {
            s = val.toString();
            if (n.normalize) {
              s = n.normalize(s);
            }
            return this.setAttribute(attr, s);
          }
        });
      }
    });
  };
  module.exports = exports;
}).call(this);
