(function() {
  var fs, loadPlugins, path, plugin;
  fs = require("fs");
  path = require("path");
  loadPlugins = function(pluginDir) {
    var availablePlugins, ext, fileArr, plugin, plugins, _i, _len;
    availablePlugins = fs.readdirSync(pluginDir);
    plugins = {};
    for (_i = 0, _len = availablePlugins.length; _i < _len; _i++) {
      plugin = availablePlugins[_i];
      fileArr = plugin.split(".");
      fileArr.pop();
      ext = fileArr.join(".");
      plugins[ext] = pluginDir + "/" + plugin;
    }
    return plugins;
  };
  plugin = exports.plugin = function(availablePlugins) {
    var plugins;
    plugins = availablePlugins;
    return function(asset) {
      var ext;
      ext = path.extname(asset).substring(1);
      if (!plugins[ext]) {
        return false;
      } else {
        return require(plugins[ext]);
      }
    };
  };
  module.exports = (function() {
    var plugins;
    plugins = loadPlugins("" + __dirname + "/plugins");
    return plugin(plugins);
  })();
}).call(this);
