(function() {
  var CommentParser, app, express, fs, lib, path, serve;
  express = require("express");
  path = require("path");
  app = express.createServer();
  lib = __dirname;
  CommentParser = require("./parsers/comments");
  fs = require("fs");
  serve = exports.serve = function(appDir, port) {
    app.configure(function() {
      app.use(express.methodOverride());
      app.use(express.bodyParser());
      app.use(express.favicon());
      app.use(require("./middleware")(appDir));
      return app.use(express['static'](appDir));
    });
    app.register('.html', {
      compile: function(str) {
        return function() {
          return str;
        };
      }
    });
    app.get("/:module?/", function(req, res) {
      var baseDir, file, index, module;
      module = req.params["module"] || "";
      index = module ? "" + module + ".html" : "app.html";
      baseDir = appDir + module + "/";
      file = baseDir + index;
      return fs.readFile(file, "utf8", function(err, html) {
        var parser;
        parser = new CommentParser(html, baseDir);
        return parser.parse(null, null, function(document) {
          return res.send(document.innerHTML);
        });
      });
    });
    return app.listen(port);
  };
  module.exports = exports;
}).call(this);
