(function() {
  var copy, countdown, fillArray, fs, mkdir, path, readFiles, toKeys, toValues, writeFiles, _;
  fs = require("fs");
  _ = require("underscore");
  path = require("path");
  readFiles = exports.readFiles = function(files, callback) {
    var file, filesLeft, val, _results;
    filesLeft = files.length;
    files = toKeys(files);
    _results = [];
    for (file in files) {
      val = files[file];
      _results.push((function(file) {
        return fs.readFile(file, "utf8", function(err, code) {
          if (err) {
            throw err;
          }
          files[file] = code;
          filesLeft--;
          if (filesLeft === 0) {
            return callback(null, files);
          }
        });
      })(file));
    }
    return _results;
  };
  writeFiles = exports.writeFiles = function(files, to, callback) {
    var code, file, finished, _results;
    finished = countdown(_.size(files));
    _results = [];
    for (file in files) {
      code = files[file];
      _results.push(fs.writeFiles(to + file, code, "utf8", function(err) {
        if (err) {
          throw err;
        }
        if (finished()) {
          return callback(null);
        }
      }));
    }
    return _results;
  };
  toValues = exports.toValues = function(array, prefix) {
    var hash, i, item, _len;
    if (prefix == null) {
      prefix = "";
    }
    hash = {};
    for (i = 0, _len = array.length; i < _len; i++) {
      item = array[i];
      hash[prefix + i] = item;
    }
    return hash;
  };
  toKeys = exports.toKeys = function(array, prefix) {
    var hash, i, item, _len;
    if (prefix == null) {
      prefix = "";
    }
    hash = {};
    for (i = 0, _len = array.length; i < _len; i++) {
      item = array[i];
      hash[prefix + item] = "";
    }
    return hash;
  };
  copy = exports.copy = function(file, to, callback) {
    return fs.readFile(file, function(err, code) {
      var filename;
      if (err) {
        throw err;
      }
      filename = path.basename(file);
      return fs.writeFile(to + "/" + filename, code, function(err) {
        if (err) {
          throw err;
        }
        return callback(null);
      });
    });
  };
  countdown = exports.countdown = function(length) {
    var left;
    left = length;
    return function() {
      left--;
      if (left <= 0) {
        return true;
      } else {
        return false;
      }
    };
  };
  fillArray = exports.fillArray = function(length, value) {
    var num, _results;
    _results = [];
    for (num = 0; 0 <= length ? num < length : num > length; 0 <= length ? num++ : num--) {
      _results.push(value);
    }
    return _results;
  };
  mkdir = exports.mkdir = function(path) {
    return fs.mkdir(path, 0777, err);
  };
  module.exports = exports;
}).call(this);
